[page:BufferGeometry] →

# [name]

Generate geometry representing a parametric surface.

## Import

[name] is an add-on, and must be imported explicitly. See [link:#manual/introduction/Installation Installation / Addons].

`import { ParametricGeometry } from 'three/addons/geometries/ParametricGeometry.js';`

## Code Example

`const geometry = new THREE.ParametricGeometry( THREE.ParametricGeometries.klein, 25, 25 ); const material = new THREE.MeshBasicMaterial( { color: 0x00ff00 } ); const klein = new THREE.Mesh( geometry, material ); scene.add( klein );`

## Constructor

### [name]([param:Function func], [param:Integer slices], [param:Integer stacks])

func — A function that takes in a [page:Float u] and [page:Float v] value each between 0 and 1 and modifies a third [page:Vector3] argument. Default is a function that generates a curved plane surface.
slices — The count of slices to use for the parametric function. Default is *8*.
stacks — The count of stacks to use for the parametric function. Default is *8*.

## Properties

See the base [page:BufferGeometry] class for common properties.

### [property:Object parameters]

An object with a property for each of the constructor parameters. Any modification after instantiation does not change the geometry.

## Methods

See the base [page:BufferGeometry] class for common methods.

## Source

[link:https://github.com/mrdoob/three.js/blob/master/examples/jsm/geometries/ParametricGeometry.js examples/jsm/geometries/ParametricGeometry.js]